8008: Incorporate SSO package testing into general package testing framework.
[arvados-dev.git] / jenkins / run-library.sh
1 #!/bin/bash
2
3 # A library of functions shared by the various scripts in this directory.
4
5 # This is the timestamp about when we merged changed to include licenses
6 # with Arvados packages.  We use it as a heuristic to add revisions for
7 # older packages.
8 LICENSE_PACKAGE_TS=20151208015500
9
10 debug_echo () {
11     echo "$@" >"$STDOUT_IF_DEBUG"
12 }
13
14 find_easy_install() {
15     for version_suffix in "$@"; do
16         if "easy_install$version_suffix" --version >/dev/null 2>&1; then
17             echo "easy_install$version_suffix"
18             return 0
19         fi
20     done
21     cat >&2 <<EOF
22 $helpmessage
23
24 Error: easy_install$1 (from Python setuptools module) not found
25
26 EOF
27     exit 1
28 }
29
30 format_last_commit_here() {
31     local format="$1"; shift
32     TZ=UTC git log -n1 --first-parent "--format=format:$format" .
33 }
34
35 version_from_git() {
36   # Generates a version number from the git log for the current working
37   # directory, and writes it to stdout.
38   local git_ts git_hash
39   declare $(format_last_commit_here "git_ts=%ct git_hash=%h")
40   echo "0.1.$(date -ud "@$git_ts" +%Y%m%d%H%M%S).$git_hash"
41 }
42
43 nohash_version_from_git() {
44     version_from_git | cut -d. -f1-3
45 }
46
47 timestamp_from_git() {
48     format_last_commit_here "%ct"
49 }
50
51 handle_python_package () {
52   # This function assumes the current working directory is the python package directory
53   if [ -n "$(find dist -name "*-$(nohash_version_from_git).tar.gz" -print -quit)" ]; then
54     # This package doesn't need rebuilding.
55     return
56   fi
57   # Make sure only to use sdist - that's the only format pip can deal with (sigh)
58   python setup.py $DASHQ_UNLESS_DEBUG sdist
59 }
60
61 handle_ruby_gem() {
62     local gem_name="$1"; shift
63     local gem_version="$(nohash_version_from_git)"
64     local gem_src_dir="$(pwd)"
65
66     if ! [[ -e "${gem_name}-${gem_version}.gem" ]]; then
67         find -maxdepth 1 -name "${gem_name}-*.gem" -delete
68
69         # -q appears to be broken in gem version 2.2.2
70         $GEM build "$gem_name.gemspec" $DASHQ_UNLESS_DEBUG >"$STDOUT_IF_DEBUG" 2>"$STDERR_IF_DEBUG"
71     fi
72 }
73
74 # Usage: package_go_binary services/foo arvados-foo "Compute foo to arbitrary precision"
75 package_go_binary() {
76     local src_path="$1"; shift
77     local prog="$1"; shift
78     local description="$1"; shift
79     local license_file="${1:-agpl-3.0.txt}"; shift
80
81     debug_echo "package_go_binary $src_path as $prog"
82
83     local basename="${src_path##*/}"
84
85     mkdir -p "$GOPATH/src/git.curoverse.com"
86     ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git"
87
88     cd "$GOPATH/src/git.curoverse.com/arvados.git/$src_path"
89     local version="$(version_from_git)"
90     local timestamp="$(timestamp_from_git)"
91
92     # If the command imports anything from the Arvados SDK, bump the
93     # version number and build a new package whenever the SDK changes.
94     if grep -qr git.curoverse.com/arvados .; then
95         cd "$GOPATH/src/git.curoverse.com/arvados.git/sdk/go"
96         if [[ $(timestamp_from_git) -gt "$timestamp" ]]; then
97             version=$(version_from_git)
98         fi
99     fi
100
101     cd $WORKSPACE/packages/$TARGET
102     go get "git.curoverse.com/arvados.git/$src_path"
103     fpm_build "$GOPATH/bin/$basename=/usr/bin/$prog" "$prog" 'Curoverse, Inc.' dir "$version" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=$description" "$WORKSPACE/$license_file=/usr/share/doc/$prog/$license_file"
104 }
105
106 default_iteration() {
107     local package_name="$1"; shift
108     local package_version="$1"; shift
109     local iteration=1
110     if [[ $package_version =~ ^0\.1\.([0-9]{14})(\.|$) ]] && \
111            [[ ${BASH_REMATCH[1]} -le $LICENSE_PACKAGE_TS ]]; then
112         iteration=2
113     fi
114     echo $iteration
115 }
116
117 _build_rails_package_scripts() {
118     local pkgname="$1"; shift
119     local destdir="$1"; shift
120     local srcdir="$RUN_BUILD_PACKAGES_PATH/rails-package-scripts"
121     for scriptname in postinst prerm postrm; do
122         cat "$srcdir/$pkgname.sh" "$srcdir/step2.sh" "$srcdir/$scriptname.sh" \
123             >"$destdir/$scriptname" || return $?
124     done
125 }
126
127 handle_rails_package() {
128     local pkgname="$1"; shift
129     local srcdir="$1"; shift
130     local license_path="$1"; shift
131     local scripts_dir="$(mktemp --tmpdir -d "$pkgname-XXXXXXXX.scripts")" && \
132     local version_file="$(mktemp --tmpdir "$pkgname-XXXXXXXX.version")" && (
133         set -e
134         _build_rails_package_scripts "$pkgname" "$scripts_dir"
135         cd "$srcdir"
136         mkdir -p tmp
137         version_from_git >"$version_file"
138         git rev-parse HEAD >git-commit.version
139         bundle package --all
140     )
141     if [[ 0 != "$?" ]] || ! cd "$WORKSPACE/packages/$TARGET"; then
142         echo "ERROR: $pkgname package prep failed" >&2
143         rm -rf "$scripts_dir" "$version_file"
144         EXITCODE=1
145         return 1
146     fi
147     local railsdir="/var/www/${pkgname%-server}/current"
148     local -a pos_args=("$srcdir/=$railsdir" "$pkgname" "Curoverse, Inc." dir
149                        "$(cat "$version_file")")
150     local license_arg="$license_path=$railsdir/$(basename "$license_path")"
151     # --iteration=3 accommodates the package scripts change from #8014.
152     local -a switches=(--iteration=3
153                        --after-install "$scripts_dir/postinst"
154                        --before-remove "$scripts_dir/prerm"
155                        --after-remove "$scripts_dir/postrm")
156     # For some reason fpm excludes need to not start with /.
157     local exclude_root="${railsdir#/}"
158     # .git and packages are for the SSO server, which is built from its
159     # repository root.
160     for exclude in .git packages tmp log coverage \
161                         Capfile\* config/deploy\*; do
162         switches+=(-x "$exclude_root/$exclude")
163     done
164     fpm_build "${pos_args[@]}" "${switches[@]}" \
165               -x "$exclude_root/vendor/bundle" "$@" "$license_arg"
166     rm -rf "$scripts_dir" "$version_file"
167 }
168
169 # Build packages for everything
170 fpm_build () {
171   # The package source.  Depending on the source type, this can be a
172   # path, or the name of the package in an upstream repository (e.g.,
173   # pip).
174   PACKAGE=$1
175   shift
176   # The name of the package to build.  Defaults to $PACKAGE.
177   PACKAGE_NAME=${1:-$PACKAGE}
178   shift
179   # Optional: the vendor of the package.  Should be "Curoverse, Inc." for
180   # packages of our own software.  Passed to fpm --vendor.
181   VENDOR=$1
182   shift
183   # The type of source package.  Passed to fpm -s.  Default "python".
184   PACKAGE_TYPE=${1:-python}
185   shift
186   # Optional: the package version number.  Passed to fpm -v.
187   VERSION=$1
188   shift
189
190   case "$PACKAGE_TYPE" in
191       python)
192           # All Arvados Python2 packages depend on Python 2.7.
193           # Make sure we build with that for consistency.
194           set -- "$@" --python-bin python2.7 \
195               --python-easyinstall "$EASY_INSTALL2" \
196               --python-package-name-prefix "$PYTHON2_PKG_PREFIX" \
197               --depends "$PYTHON2_PACKAGE"
198           ;;
199       python3)
200           # fpm does not actually support a python3 package type.  Instead
201           # we recognize it as a convenience shortcut to add several
202           # necessary arguments to fpm's command line later, after we're
203           # done handling positional arguments.
204           PACKAGE_TYPE=python
205           set -- "$@" --python-bin python3 \
206               --python-easyinstall "$EASY_INSTALL3" \
207               --python-package-name-prefix "$PYTHON3_PKG_PREFIX" \
208               --depends "$PYTHON3_PACKAGE"
209           ;;
210   esac
211
212   declare -a COMMAND_ARR=("fpm" "--maintainer=Ward Vandewege <ward@curoverse.com>" "-s" "$PACKAGE_TYPE" "-t" "$FORMAT")
213   if [ python = "$PACKAGE_TYPE" ]; then
214     COMMAND_ARR+=(--exclude=\*/{dist,site}-packages/tests/\*)
215   fi
216
217   if [[ "$PACKAGE_NAME" != "$PACKAGE" ]]; then
218     COMMAND_ARR+=('-n' "$PACKAGE_NAME")
219   fi
220
221   if [[ "$VENDOR" != "" ]]; then
222     COMMAND_ARR+=('--vendor' "$VENDOR")
223   fi
224
225   if [[ "$VERSION" != "" ]]; then
226     COMMAND_ARR+=('-v' "$VERSION")
227   fi
228   # We can always add an --iteration here.  If another one is specified in $@,
229   # that will take precedence, as desired.
230   COMMAND_ARR+=(--iteration "$(default_iteration "$PACKAGE" "$VERSION")")
231
232   # 'dir' type packages are provided in the form /path/to/source=/path/to/dest
233   # so strip off the 2nd part to check for fpm-info below.
234   PACKAGE_DIR=$(echo $PACKAGE | sed 's/\/=.*//')
235
236   # Append --depends X and other arguments specified by fpm-info.sh in
237   # the package source dir. These are added last so they can override
238   # the arguments added by this script.
239   declare -a fpm_args=()
240   declare -a fpm_depends=()
241   if [[ -d "$PACKAGE_DIR" ]]; then
242       FPM_INFO="$PACKAGE_DIR/fpm-info.sh"
243   else
244       FPM_INFO="${WORKSPACE}/backports/${PACKAGE_TYPE}-${PACKAGE}/fpm-info.sh"
245   fi
246   if [[ -e "$FPM_INFO" ]]; then
247       debug_echo "Loading fpm overrides from $FPM_INFO"
248       source "$FPM_INFO"
249   fi
250   for i in "${fpm_depends[@]}"; do
251     COMMAND_ARR+=('--depends' "$i")
252   done
253   COMMAND_ARR+=("${fpm_args[@]}")
254
255   # Append remaining function arguments directly to fpm's command line.
256   for i; do
257     COMMAND_ARR+=("$i")
258   done
259
260   COMMAND_ARR+=("$PACKAGE")
261
262   debug_echo -e "\n${COMMAND_ARR[@]}\n"
263
264   FPM_RESULTS=$("${COMMAND_ARR[@]}")
265   FPM_EXIT_CODE=$?
266
267   fpm_verify $FPM_EXIT_CODE $FPM_RESULTS
268 }
269
270 # verify build results
271 fpm_verify () {
272   FPM_EXIT_CODE=$1
273   shift
274   FPM_RESULTS=$@
275
276   FPM_PACKAGE_NAME=''
277   if [[ $FPM_RESULTS =~ ([A-Za-z0-9_\.-]*\.)(deb|rpm) ]]; then
278     FPM_PACKAGE_NAME=${BASH_REMATCH[1]}${BASH_REMATCH[2]}
279   fi
280
281   if [[ "$FPM_PACKAGE_NAME" == "" ]]; then
282     EXITCODE=1
283     echo "Error: $PACKAGE: Unable to figure out package name from fpm results:"
284     echo
285     echo $FPM_RESULTS
286     echo
287   elif [[ "$FPM_RESULTS" =~ "File already exists" ]]; then
288     echo "Package $FPM_PACKAGE_NAME exists, not rebuilding"
289   elif [[ 0 -ne "$FPM_EXIT_CODE" ]]; then
290     echo "Error building package for $1:\n $FPM_RESULTS"
291   fi
292 }
293
294 install_package() {
295   PACKAGES=$@
296   if [[ "$FORMAT" == "deb" ]]; then
297     $SUDO apt-get install $PACKAGES --yes
298   elif [[ "$FORMAT" == "rpm" ]]; then
299     $SUDO yum -q -y install $PACKAGES
300   fi
301 }